-- Priority List 3
-- by Jadya
-- EU-Well of Eternity

-- tab 2

local addonName, addonTable = ...
local L = addonTable.L
local AddColor = addonTable.AddColor

local addon = PriorityList
local wishlist = addon.WishListFunctions
local chars = addon.CharFunctions
local items = addon.ItemFunctions

local listbox, dd_char

local function onShow()
 dd_char:SetParent(PLTabFrame2)
 dd_char:Show()
 PLListbox:Show()
end

local function onHide()

end

local function updateListButton(self, list, index)
 if index > #list then return end
 data = list[index]

 self.t = "item"
  local name, _, quality, _, _, _, _, _, equipSlot, texture = items:GetItemInfo(data.itemID)
 if data.personal then
  self.background:SetVertexColor(0.2,1,0.6,0.1)
 else
  self.background:SetVertexColor(0.2,0.6,1,0.1)
 end
 if not name then
  self.lefticon:SetTexture("Interface\\ICONS\\Ability_Mage_TimeWarp")
  self.s_topleft:SetText(AddColor(L["receiving_item_info"], "GOLD"))
  self.s_bottomleft:SetText("")
  self.s_topright:SetText("")
  self.s_bottomright:SetText("")
 else
  self.link = data.link
  local bns = items:GetBonusString(items:ExtractBonuses(data.link))
  self.s_topright:SetText((AddColor(L["looted"]..(bns ~= "" and " -"..bns or ""), "LIGHT_BLUE") or ""))
  self.lefticon:SetTexture(texture)
  local _,_,_,c = GetItemQualityColor(quality)
  self.s_topleft:SetText((c and ("|c"..c) or "")..name.."|r")
  self.s_bottomleft:SetText("")
  --self.s_bottomleft:SetText(AddColor(data.time and date(nil, tonumber(data.time)) or "<unknown date>", "GRAY"))
  self.s_bottomright:SetText("")
 end
 return true
end

local function listboxUpdate(self)
 local list = PLWish_List[addon.sel_char] and PLWish_List[addon.sel_char][addon.sel_difficulty].looted

 if not list then
  self:HideButtons()
  return
 end

 wipe(self.list)
 for k,v in pairs(list) do
  self.list[#self.list + 1] = { link = v.link, time = tonumber(v.time), itemID = k, personal = v.personal }
 end
 table.sort(self.list, addon.sortbytime)
end

function addon.PLTab2Show(p)
 local ng = NyxGUI("1.0")

 if not p.initialized then
  p.initialized = true
  dd_char = PLDDCharacters
  
   -- listbox
  local f = ng:New(addonName, "Listbox", "PLListbox", p)
  local bg_model = CreateFrame("Model", nil, f)
  bg_model:SetModel("interface\\glues\\models\\ui_orc\\ui_orc.m2")
  bg_model:SetAllPoints()
  bg_model:SetFrameStrata(f:GetFrameStrata())
  bg_model:SetFrameLevel(f:GetFrameLevel())
  f.bg_model = bg_model
  f.list = {}

  f.update_pre = listboxUpdate
  f.update_button = updateListButton
  f:SetPoint("TOPLEFT", 10, -75)
  f:SetPoint("BOTTOMRIGHT", -30, 10)
  f:Initialize("PLListButtonTemplate")
  f.hideSelection = true

  for k,v in pairs(f.buttons) do
   v:SetFrameStrata(f:GetFrameStrata())
   v:SetFrameLevel(f:GetFrameLevel() + 2)
   v:SetScript("OnEnter", listButtonOnEnter)
   v:SetScript("OnLeave", listButtonOnLeave)
   v:SetBackdropColor(0,0,0,0.6)
   v:SetBackdropBorderColor(0,0,0,0)
  end
  
  listbox = f
  
  addon:Hook("CHAR_SELECTED", function(name)
                               dd_char:SetText(name)
                               if listbox:IsVisible() then listbox:update() end
                              end)
  
  addon:Hook("PRIO_CHANGED", function() if listbox:IsVisible() then listbox:update() end end)
  --
 end

 dd_char:SetParent(p)
 listbox:update()
end